/*====================================+=====================================+
! File CDlgAddLive.h                  ! Copyright (C) 2016-2018 Remi PASCAL !
+-------------------------------------+-------------------------------------+
! This file is part of matelefree.                                          !
! matelefree is free software: you can redistribute it and/or modify it     !
! under the terms of the GNU General Public License as published by the     !
! Free Software Foundation, either version 3 of the License, or any later   !
! version.                                                                  !
! matelefree is distributed in the hope that it will be useful, but WITHOUT !
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     !
! FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for !
! more details.                                                             !
! You should have received a copy of the GNU General Public License along   !
! with matelefree. If not, see <http://www.gnu.org/licenses/>.              !
+==========================================================================*/



/*-------------------------------------------------------------------------*/
#pragma once
/*-------------------------------------------------------------------------*/
#include <vector>
#include <wx/listctrl.h>
#include "matelefree.h"
#include "CPlaylist.h"
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
class CDlgAddLive ;
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
struct str_live_info
{  /*----------------------------------------------------------------------*/
   wxString m_s_id ;
   wxString m_s_name ;
   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
using t_vec_live_info     = std::vector< str_live_info >    ;
using t_vec_live_info_it  = t_vec_live_info::iterator       ;
using t_vec_live_info_cit = t_vec_live_info::const_iterator ;

/*-------------------------------------------------------------------------*/
class CLiveList : public wxListCtrl
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CLiveList( CDlgAddLive *dlg, CPlaylistLive *pl ) ;
      //~CLiveList() ;

   /*----------------------------------------------------------------------*/
   protected :
      /*-------------------------------------------------------------------*/
      CDlgAddLive     *m_dlg ;
      CPlaylistLive   *m_pl ;
      t_vec_live_info m_vec_live_info ;

   /*----------------------------------------------------------------------*/
   protected :
      /*-------------------------------------------------------------------*/
      virtual wxString OnGetItemText( long l_item, long l_column
                                    ) const override ;

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      void init_item_count() ;
      void del_entry( const wxString &s_id ) ;
      void add_channel( int i_item ) ;

   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
class CDlgAddLive : public wxDialog
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CDlgAddLive( wxWindow *parent, CPlaylistLive *pl ) ;
      ~CDlgAddLive() ;

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CPlaylistLive *m_pl ;
      wxTextCtrl    *m_txt_url ;
      wxStaticText  *m_stx_msg ;
      CLiveList     *m_list ;

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      virtual void OnURLEnter( wxCommandEvent &event ) ;
      /*-------------------------------------------------------------------*/
      void msg_error( const wxString &s_msg ) ;
      void msg_info( const wxString &s_msg ) ;
      void clear_msg() ;
      int add_channel_by_url( const wxString &s_url ) ;
      int get_modal() ;

   /*----------------------------------------------------------------------*/

} ;

/*-------------------------------------------------------------------------*/



/*==========================================================================+
!                         End of file CDlgAddLive.h                         !
+==========================================================================*/
