/*====================================+=====================================+
! File matelefree.h                   ! Copyright (C) 2016-2018 Remi PASCAL !
+-------------------------------------+-------------------------------------+
! This file is part of matelefree.                                          !
! matelefree is free software: you can redistribute it and/or modify it     !
! under the terms of the GNU General Public License as published by the     !
! Free Software Foundation, either version 3 of the License, or any later   !
! version.                                                                  !
! matelefree is distributed in the hope that it will be useful, but WITHOUT !
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     !
! FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for !
! more details.                                                             !
! You should have received a copy of the GNU General Public License along   !
! with matelefree. If not, see <http://www.gnu.org/licenses/>.              !
+---------+-----------------------------------------------------------------+
! History !                                                                 !
+---------+                                                                 !
! Date        Version  Description                                          !
! ----------  -------  ---------------------------------------------------- !
! 2018/08/09  1.21     1.21 released (build 571) (Bug fb playlist)          !
! 2018/08/05  1.20     1.20 released (build 569) (TNT except 6play)         !
! 2018/06/29  1.10     1.10 released (build 549)                            !
! 2018/06/10  1.10     beta  1 build 547 released (viewers,periscope,mixer) !
! 2018/03/31  1.01     1.01 released (build 507)                            !
! 2018/03/11  1.00     1.00 released (build 504)                            !
! 2018/03/04  1.00     rc    3 build 498 released                           !
! 2018/02/18  1.00     rc    3 build 493 released                           !
! 2018/01/07  1.00     rc    2 build 480 released                           !
! 2017/12/17  1.00     rc    1 build 477 released (disable sys libs)        !
! 2017/11/22  1.00     beta  2 build 468 released (taskbar icon)            !
! 2017/10/18  1.00     beta  1 build 450 released (mini display mode modif) !
! 2017/10/09  1.00     alpha 5 build 447 released (play crash cancel prefs) !
! 2017/10/08  1.00     alpha 5 build 446 released (ustream vlc init string) !
! 2017/10/07  1.00     alpha 5 build 445 released                           !
! 2017/09/16  1.00     alpha 5 build 433 released                           !
! 2017/07/30  1.00     alpha 4 build 410 released                           !
! 2017/06/04  1.00     alpha 3 build 373 released                           !
! 2017/02/27  1.00     alpha 2 build 298 released                           !
! 2017/02/26  1.00     alpha 2 build 295 released                           !
! 2017/01/08  1.00     alpha 1 build 285 released                           !
! 2017/01/07  1.00     alpha 1 build 284 released                           !
! 2017/01/05  1.00     alpha 1 build 282 released                           !
! 2017/01/03  1.00     alpha 1 build 281 released                           !
! 2017/01/01  1.00     alpha 1 build 278 released                           !
!                                                                           !
+==========================================================================*/



/*-------------------------------------------------------------------------*/
#pragma once
/*-------------------------------------------------------------------------*/
#include <vector>
#include <map>
#include <deque>
#include <list>
/*-------------------------------------------------------------------------*/
#include <wx/wx.h>
#include <wx/app.h>
#include <wx/artprov.h>
#include <wx/menu.h>
#include <wx/mstream.h>
/*-------------------------------------------------------------------------*/
class CConfigRect ;
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
namespace mtf
{
/*-------------------------------------------------------------------------*/
using wxString_it      = wxString::iterator ;
using wxString_cit     = wxString::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_vec_string     = std::vector< wxString > ;
using t_vec_string_it  = t_vec_string::iterator ;
using t_vec_string_cit = t_vec_string::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_vec_int        = std::vector< int > ;
using t_vec_int_it     = t_vec_int::iterator ;
using t_vec_int_cit    = t_vec_int::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_map_strstr     = std::map< wxString, wxString > ;
using t_map_strstr_it  = t_map_strstr::iterator ;
using t_map_strstr_cit = t_map_strstr::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_map_strint     = std::map< wxString, int > ;
using t_map_strint_it  = t_map_strint::iterator ;
using t_map_strint_cit = t_map_strint::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_map_intstr     = std::map< int, wxString > ;
using t_map_intstr_it  = t_map_intstr::iterator ;
using t_map_intstr_cit = t_map_intstr::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_deq_string     = std::deque< wxString > ;
using t_deq_string_it  = t_deq_string::iterator ;
using t_deq_string_cit = t_deq_string::const_iterator ;
/*-------------------------------------------------------------------------*/
using t_lst_string     = std::list< wxString > ;
using t_lst_string_it  = t_lst_string::iterator ;
using t_lst_string_cit = t_lst_string::const_iterator ;
/*-------------------------------------------------------------------------*/
wxMenuItem *insert_item( wxMenu *menu, int i_pos, int i_id,
                         const wxString &s_item,
                         const wxBitmap &bmp /*= wxNullBitmap*/,
                         const wxString &s_help = wxEmptyString,
                         wxItemKind mik = wxITEM_NORMAL,
                         wxMenu *p_submenu = nullptr
                       ) ;
wxMenuItem *append_item( wxMenu *menu, int i_id,
                         const wxString &s_item,
                         const wxBitmap &bmp /*= wxNullBitmap*/,
                         const wxString &s_help = wxEmptyString,
                         wxItemKind mik = wxITEM_NORMAL,
                         wxMenu *p_submenu = nullptr
                       ) ;
wxBitmap get_menu_bmp( const wxArtID &id ) ;
wxBitmap get_toolbar_bmp( const wxArtID &id ) ;
wxMenuItem *append_item( wxMenu *menu, int i_id, const wxArtID &artid ) ;
wxMenuItem *append_item( wxMenu *dst, wxMenuItem *mi_src ) ;
wxMenuItem *append_item( wxMenu *dst, wxMenu *src, int i_id ) ;
wxMenuItem *append_item( wxMenu *dst, wxMenuBar *src, int i_id ) ;
void append_menu( wxMenu *dst, wxMenu *src ) ;
int wxs2int( const wxString &s ) ;
void set_clipboard( const wxString &s ) ;
wxString unspace( wxString s ) ;
wxString unaccent( wxString s ) ;
wxString prepare_string( const wxString &s ) ;
wxString unhtml( const wxString &s ) ;
int check_ini_entry_name( const wxString &s_name, wxString &s_err_msg ) ;
/*-------------------------------------------------------------------------*/
void tlw_set_rect( wxWindow *p_win, const wxRect &rect ) ;
void init_tlw_rect( wxWindow *p_win, const CConfigRect &cfg_rect ) ;
void save_tlw_rect( wxWindow *p_win, CConfigRect &cfg_rect ) ;
/*-------------------------------------------------------------------------*/
void draw_wrapped( wxDC &dc, const wxString &s ) ;
/*-------------------------------------------------------------------------*/
#ifdef __WXMSW__
int msw_exe_bitness( const wxString &s_filename ) ;
#endif
/*-------------------------------------------------------------------------*/
wxString read_m3u_line( wxTextInputStream &tis, int &i_line_num ) ;
wxString read_line( wxTextInputStream &tis, int &i_line_num ) ;
int match( const wxString &s_data, const wxString &s_re ... ) ;
wxString urlencode( const wxString &s_in ) ;
int unshort_url( wxString &s_url, wxString *p_s_err_msg ) ;
int download( const wxString &s_url, wxString &s_data,
              wxString *p_s_last_url = nullptr, int i_connect_timeout = -1,
              const t_lst_string &lst_header = t_lst_string(),
              const wxString &s_post = wxEmptyString
            ) ;
int download( const wxString &s_url, wxMemoryOutputStream &mos,
              wxString *p_s_last_url = nullptr, int i_connect_timeout = -1,
              const t_lst_string &lst_header = t_lst_string(),
              const wxString &s_post = wxEmptyString
            ) ;
/*-------------------------------------------------------------------------*/
wxString get_debug_filename() ;
void trace( const wxString &s ) ;

/*-------------------------------------------------------------------------*/
constexpr int co_i_pl_menu_size   = 100 ;
constexpr int co_i_play_hist_size =  10 ;
/*-------------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
enum e_id_control
{
   /*----------------------------------------------------------------------*/
   ID_DUMMY_FIRST = wxID_HIGHEST + 1,
   ID_STAY_ON_TOP,
   ID_TOGGLE_MINI_DISPLAY,
   ID_TOGGLE_SHOW,
   ID_TOGGLE_CAPTION,
   ID_DISP_BOPL,
   ID_DISP_PL,
   ID_DISP_CTRL,
   ID_PL_START,
   ID_PL_END = ID_PL_START + mtf::co_i_pl_menu_size,
   ID_PLAY_START_PAUSE,
   ID_PLAY_STOP,
   ID_PLAY_STOP_ALL,
   ID_PLAY_PREV,
   ID_PLAY_NEXT,
   ID_PLAY_HIST,
   ID_PLAY_HIST_MENU,
   ID_PLAY_HIST_START,
   ID_PLAY_HIST_END = ID_PLAY_HIST_START + mtf::co_i_play_hist_size,
   ID_PLAY_HIST_CLEAR,
   ID_FIND_PLAYED_ACTIVE,
   ID_FULLSCREEN,
   ID_SNAPSHOT,
   ID_TOGGLE_MUTE,
   ID_VOLUME_UP,
   ID_VOLUME_DOWN,
   ID_MAKE_DONATION,
   ID_MOVE_UP,
   ID_MOVE_DOWN,
   ID_WEB_SITE_MAIN,
   ID_WEB_SITE_FORUM,
   ID_CHECK_VERSION_MANUAL
   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
enum e_pl_known
{  PK_FBTV, PK_FBTVB, PK_FBTVO, PK_FBTVO_OK, PK_FBRADIO, PK_SEARCH,
   PK_LIVE_NODE, PK_LIVE_DM, PK_LIVE_TW, PK_LIVE_YT, PK_LIVE_US,
   PK_LIVE_PE, PK_LIVE_MX,
   PK_USER_NODE, PK_NB
} ;

/*-------------------------------------------------------------------------*/
enum e_chkupd_freq { CUF_NEVER, CUF_DAY, CUF_WEEK, CUF_MONTH, CUF_NB } ;

/*-------------------------------------------------------------------------*/
enum e_download_id { DID_VERSION, DID_NB } ;

/*--------------------------------------------------------------------------+
! Fullscreen has 3 "levels" or types :                                      !
! - no fullscreen                                                           !
! - all media are displayed tiled on the screen                             !
! - only one media is displayed                                             !
+--------------------------------------------------------------------------*/
enum e_fullscreen_level { FSL_NONE, FSL_ALL_MEDIA, FSL_ONE_MEDIA, FSL_NB } ;

/*-------------------------------------------------------------------------*/
class CBoolInScope
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CBoolInScope( bool &boo_var ) : m_boo_var( boo_var )
      {  m_boo_var = true ; }
      ~CBoolInScope()
      {  m_boo_var = false ; }

   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      bool &m_boo_var ;
      /*-------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
class CDlgProgress : public wxDialog
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      CDlgProgress( wxWindow *parent ) ;
      //~CDlgProgress();

   /*----------------------------------------------------------------------*/
   protected :
      /*-------------------------------------------------------------------*/
      wxBoxSizer   *m_bsz_gen ;
      wxStaticText *m_stx_msg ;
      wxGauge      *m_ga_progress ;
      wxButton     *m_bt_quit ;

   /*----------------------------------------------------------------------*/
   protected :
      /*-------------------------------------------------------------------*/
      virtual void OnBtCancel( wxCommandEvent& event ) { event.Skip() ; }
   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/



/*==========================================================================+
!                         End of file matelefree.h                          !
+==========================================================================*/
